/*
**	GadTools layout toolkit
**
**	Copyright  1993-1996 by Olaf `Olsen' Barthel
**		Freely distributable.
**
**	:ts=4
*/

#ifndef _GTLAYOUT_GLOBAL_H
#include "gtlayout_global.h"
#endif

/****** gtlayout.library/LT_PressButton ******************************************
*
*   NAME
*	LT_PressButton -- Highlight a button so it looks as if the user
*	                  has selected it.
*
*   SYNOPSIS
*	LT_PressButton(Handle,ID);
*	                  A0  D0
*
*	VOID LT_PressButton(LayoutHandle *,LONG);
*
*   FUNCTION
*	You can provide visual feedback for BUTTON_KIND objects by calling
*	this routine. They will briefly appear to be selected and then
*	fall back to their original states.
*
*   INPUTS
*	Handle - Pointer to LayoutHandle structure
*
*	ID - ID of button object to highlight
*
*   RESULT
*	none
*
******************************************************************************
*
*/

VOID LIBENT
LT_PressButton(REG(a0) LayoutHandle *handle,REG(d0) LONG id)
{
	if(handle)
	{
		struct Gadget *gadget;

		if(gadget = LTP_FindGadget(handle,id))
		{
			ObjectNode *node;

			if(GETOBJECT(gadget,node))
			{
				if(!node->Disabled)
					LTP_BlinkButton(handle,gadget);
			}
		}
	}
}
